// Copyright (C) 1999 Jean-Marc Valin

#ifndef MMITRAIN_H
#define MMITRAIN_H

#include "Node.h"
#include "ObjectRef.h"

class MMITrain : public Node {

protected:
   
   /**The ID of the 'output' output*/
   int outputID;

   /**The ID of the 'frames' input*/
   int framesInputID;

   /**Reference to the current stream*/
   ObjectRef currentMMI;

   /**Number of levels to split*/
   int nb_levels;

   int processCount;

public:
   /**Constructor, takes the name of the node and a set of parameters*/
   MMITrain(string nodeName, ParameterSet params);

   /**Class specific initialization routine.
      Each class will call its subclass specificInitialize() method*/
   virtual void specificInitialize();

   /**Class reset routine.
      Each class will call its superclass reset() method*/
   virtual void reset();

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

protected:
   /**Default constructor, should not be used*/
   MMITrain() {throw new GeneralException("MMITrain copy constructor should not be called",__FILE__,__LINE__);}

};

#endif
