// Copyright (C) 1999 Dominic Letourneau

#ifndef HISTOGRAM_H
#define HISTOGRAM_H

#include "Node.h"
#include "Vector.h"

///class Histogram
class Histogram : public Node {

protected:

   ObjectRef histogram;

   ///Our InputID
   int inputID;

   ///Out OutputID
   int outputID;

   ///The histogram size
   int size;

   int processCount;

public:

   ///Constructor, takes the name of the node and a set of parameters
   Histogram(string nodeName, const ParameterSet &params);

   /**Class specific initialization routine.
      Each class will call its subclass reset() method*/
   virtual void reset();

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

   /**Class specific initialization routine.
      Each class will call its subclass specificInitialize() method*/
   virtual void specificInitialize();

protected:
   ///Default constructor, should not be used
   Histogram() {throw new GeneralException("Histogram default constructor should not be called",__FILE__,__LINE__);}
};

#endif
