// Copyright (C) 1999 Dominic Letourneau

#ifndef MMI_ACCUMULATOR_H
#define MMI_ACCUMULATOR_H

#include "Node.h"
#include "Vector.h"

///class MMIAccumulator
class MMIAccumulator : public Node {

protected:

   ObjectRef accum;

   ///Our InputID
   int inputID;

   ///Out OutputID
   int outputID;

   int processCount;
public:
   ///Constructor, takes the name of the node and a set of parameters
   MMIAccumulator(string nodeName, const ParameterSet &params);

   /**Class specific initialization routine.
      Each class will call its subclass reset() method*/
   virtual void reset();

   /**Class specific initialization routine.
      Each class will call its subclass specificInitialize() method*/
   virtual void specificInitialize();

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

protected:
   ///Default constructor, should not be used
   MMIAccumulator() {throw new GeneralException("MMIAccumulator copy constructor should not be called",__FILE__,__LINE__);}
};

#endif
