// Copyright (C) 1999 Dominic Letourneau

#ifndef _OR_H_
#define _OR_H_

#include "Node.h"
#include "Exception.h"
/** 
    The OrNode takes an unlimited number of inputs (bools) and returns the
    OR result.
    - INPUTS : unlimited (bools)
    - OUTPUTS: output (bool)
    @author Dominic Letourneau
    @version 1.0
 */
class OR : public Node {

public:

   ///Constructor, takes the name of the node and a set of parameters
   OR(string nodeName, ParameterSet params);

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

   void specificInitialize() {processCount=-1;Node::specificInitialize();}

   void reset() {processCount=-1;Node::reset();}


protected:
   int processCount;

   ///symbolic to numeric translation for input names
   virtual int translateInput(string inputName);

   ObjectRef output;

   ///Default constructor, should not be used
   OR() {throw(GeneralException("OR default constructor should not be called",__FILE__,__LINE__));}

};
#endif
